#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * StreamEngineSvcChannelHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _StreamEngineSvcChannelHandler StreamEngineSvcChannelHandler;

/**
 * StreamEngineSvcChannelHandlerClass:
 *
 * The class of StreamEngineSvcChannelHandler.
 */
typedef struct _StreamEngineSvcChannelHandlerClass StreamEngineSvcChannelHandlerClass;

GType stream_engine_svc_channel_handler_get_type (void);
#define STREAM_ENGINE_TYPE_SVC_CHANNEL_HANDLER \
  (stream_engine_svc_channel_handler_get_type ())
#define STREAM_ENGINE_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), STREAM_ENGINE_TYPE_SVC_CHANNEL_HANDLER, StreamEngineSvcChannelHandler))
#define STREAM_ENGINE_IS_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), STREAM_ENGINE_TYPE_SVC_CHANNEL_HANDLER))
#define STREAM_ENGINE_SVC_CHANNEL_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), STREAM_ENGINE_TYPE_SVC_CHANNEL_HANDLER, StreamEngineSvcChannelHandlerClass))


typedef void (*stream_engine_svc_channel_handler_handle_channel_impl) (StreamEngineSvcChannelHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context);
void stream_engine_svc_channel_handler_implement_handle_channel (StreamEngineSvcChannelHandlerClass *klass, stream_engine_svc_channel_handler_handle_channel_impl impl);
/**
 * stream_engine_svc_channel_handler_return_from_handle_channel:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}


/**
 * StreamEngineSvcStreamEngine:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _StreamEngineSvcStreamEngine StreamEngineSvcStreamEngine;

/**
 * StreamEngineSvcStreamEngineClass:
 *
 * The class of StreamEngineSvcStreamEngine.
 */
typedef struct _StreamEngineSvcStreamEngineClass StreamEngineSvcStreamEngineClass;

GType stream_engine_svc_stream_engine_get_type (void);
#define STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE \
  (stream_engine_svc_stream_engine_get_type ())
#define STREAM_ENGINE_SVC_STREAM_ENGINE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE, StreamEngineSvcStreamEngine))
#define STREAM_ENGINE_IS_SVC_STREAM_ENGINE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE))
#define STREAM_ENGINE_SVC_STREAM_ENGINE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), STREAM_ENGINE_TYPE_SVC_STREAM_ENGINE, StreamEngineSvcStreamEngineClass))


typedef void (*stream_engine_svc_stream_engine_set_output_volume_impl) (StreamEngineSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_volume,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_set_output_volume (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_set_output_volume_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_set_output_volume:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_set_output_volume (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_set_output_volume (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*stream_engine_svc_stream_engine_mute_input_impl) (StreamEngineSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_mute_input (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_mute_input_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_mute_input:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_mute_input (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_mute_input (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*stream_engine_svc_stream_engine_mute_output_impl) (StreamEngineSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    gboolean in_mute_state,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_mute_output (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_mute_output_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_mute_output:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_mute_output (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_mute_output (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*stream_engine_svc_stream_engine_set_output_window_impl) (StreamEngineSvcStreamEngine *self,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint in_window,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_set_output_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_set_output_window_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_set_output_window:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_set_output_window (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_set_output_window (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*stream_engine_svc_stream_engine_add_preview_window_impl) (StreamEngineSvcStreamEngine *self,
    guint in_window,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_add_preview_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_add_preview_window_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_add_preview_window:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_add_preview_window (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_add_preview_window (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*stream_engine_svc_stream_engine_remove_preview_window_impl) (StreamEngineSvcStreamEngine *self,
    guint in_window,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_remove_preview_window (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_remove_preview_window_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_remove_preview_window:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_remove_preview_window (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_remove_preview_window (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*stream_engine_svc_stream_engine_shutdown_impl) (StreamEngineSvcStreamEngine *self,
    DBusGMethodInvocation *context);
void stream_engine_svc_stream_engine_implement_shutdown (StreamEngineSvcStreamEngineClass *klass, stream_engine_svc_stream_engine_shutdown_impl impl);
/**
 * stream_engine_svc_stream_engine_return_from_shutdown:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void stream_engine_svc_stream_engine_return_from_shutdown (DBusGMethodInvocation *context);
static inline void
stream_engine_svc_stream_engine_return_from_shutdown (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void stream_engine_svc_stream_engine_emit_receiving (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    gboolean arg_state);
void stream_engine_svc_stream_engine_emit_stream_state_changed (gpointer instance,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    guint arg_state,
    guint arg_direction);


G_END_DECLS
